package com.unipi.talepis;

import java.lang.reflect.Field;
import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;

public class Main {

    public static void main(String[] args) {
	    MyClass m1 = new MyClass("Unipi");
        try {
            Field privateField = MyClass.class.getDeclaredField("name");
            privateField.setAccessible(true);
            String s = (String)privateField.get(m1);
            System.out.println(s);
            privateField.set(m1,"Hello");
            System.out.println(m1.getName());

            Method privateMethod = MyClass.class.getDeclaredMethod("secretMethod");
            privateMethod.setAccessible(true);
            privateMethod.invoke(m1,null);
        } catch (NoSuchFieldException | IllegalAccessException | NoSuchMethodException | InvocationTargetException e) {
            e.printStackTrace();
        }
    }
}

class MyClass{
    private String name;
    private void secretMethod(){
        System.out.println("secret:12345678");
    }
    public String getName() {
        return name;
    }

    public MyClass(String name) {
        this.name = name;
    }
}
